<?php
require ("../lib-abdesk.php");
CheckCookie();
session_start();

$prevformname="file_record_editor_form";
$errorvarname="file_record_editor_error";
$dbtype="file";

  	$varstoget_fromform=array("title", "maintagstring", "othertagstring", "projectstring", "bundlestring", "otherbundlestring", "authorstring", "languagestring", "originstring", "backuplocstring", "shortdesc", "longdesc", "sourcenotes", "licensenotes", "licensetype", "type", "topic", "status", "aesthetic", "utilit", "educational", "forfun", "humorous", "news", "curio", "trivial", "unknown", "timecap", "irrep", "nostalgic", "autobio", "datasource", "clutterpile", "permloc", "maybe", "aside", "contentsimported", "repository", "fav", "important", "forsite", "deleted", "frequent", "privacy", "usefulness", "fun", "beauty", "necessity", "humorousness", "liking", "eduval", "quality", "interest", "updatefrequency", "maindateyear", "maindatemonth", "maindateday", "maindatetime", "datestartyear", "datestartmonth", "datestartday", "datestarttime", "datendyear", "datendmonth", "datendday", "datendtime", "maindatenotes", "daterangenotes", "extcat", "paired", "filename", "parentdirs", "disk", "disknick", "perorimper", "reasonforsaving", "importance", "relimport", "privacynotes", "frequent", "junkpile", "essential", "depthread", "desiretoread", "forother", "obsolete", "redundant", "deletable", "altversion", "primar", "hide", "othernotes", "relatedurls", "relatedids", "url", "toforstring", "ext", "pairedfolitem", "desiretokeep");

	$imvarstoget_fromform=array("hasthumbnail", "showthumbnail");
	
require ("../lib-tags.php");

function GoBackToFormWithError($err)
{	global $file_id, $prevformname, $errorvarname;

	$_SESSION[$errorvarname]=$err;
	header("Location: $prevformname.php?id=$file_id");
	exit;
}


$curfilesdb=$_POST[curfilesdb];
$filesdb_name=$curfilesdb;

$file_id=$_POST[file_id]; //If the previous page was an
	//Edit page, then, the ID will be here (delivered by a hidden
	//field on the last page).

	//We want to keep "raw" copies of the following variables, obtained prior to running the CleanInput function on $_POST,
	//since it's easier to compare the raw, non-escaped copies to the "prev" versions of those variables to ascertain 
	//whether the new data is different from the old data or not.
	
	$raw_varstomake=array("maintagstring", "othertagstring", "projectstring", "bundlestring", "otherbundlestring", "authorstring", "languagestring", "originstring", "backuplocstring", "toforstring", "extcat");

	foreach ($raw_varstomake as $current_var)
	{	
		$rawvarname="raw_$current_var";
		${$rawvarname}=$_POST[$current_var];
	}


if ($file_id==0)
{	$action="Add";
	header("Location: single_file_adder_form.php");
	exit;	//If the user loaded this page without submitting a form with a url_id, they shouldn't be here.
}
else
{	$action="Edit";	//This means we're editing a link already in the database.  So, this means we have to figure out
						//whether or not some of the data the user input is different from the original data.
						
		//Here, we retrieve the prev vars.
	//These make it possible to tell (without querying the DB) if a tagstring was changed.
	$prev_varstomake=array("maintagstring", "othertagstring", "projectstring", "bundlestring", "otherbundlestring", "authorstring", "languagestring", "originstring", "backuplocstring", "toforstring");
	
	foreach ($prev_varstomake as $current_var)
	{	if ($current_var!="url")
		{	$prevvarname=substr($current_var, 0, -5); //Getting rid of "tring" at the end.
		}
		else
		{	$prevvarname=$current_var;
		}
		$prevvarname="prev$prevvarname";
		${$prevvarname}=$_POST[$prevvarname];
		$_SESSION[$prevvarname]=$_POST[$prevvarname];
		${$prevvarname}=ereg_replace("&quot;", "\"", ${$prevvarname});
	}
	//Onward.  Most of the tag stuff is handled at the end, but some is in the middle.
}
	
	foreach ($varstoget_fromform as $varname)
	{
		$_SESSION[$varname]=$_POST[$varname];
	}
	if ($raw_extcat=="Image")
	{	
		foreach ($imvarstoget_fromform as $imvarname)
		{
			$_SESSION[$imvarname]=$_POST[$imvarname];
		}
	}
$handle=ConnectToDb($filesdb_name);

array_walk($_POST,'CleanInput');  
$file_id = $_POST[file_id];


	foreach ($varstoget_fromform as $varname)
	{	${$varname}=$_POST[$varname];
	}
	if ($raw_extcat=="Image")
	{	
		foreach ($imvarstoget_fromform as $imvarname)
		{
			${$imvarname}=$_POST[$imvarname];
		}
	}
	
$filestuff = "<a href=\"file://localhost/$disk:/$parentdirs/$filename";

if ($ext)
{	$filestuff .= ".$ext";
}

$filestuff .= "\">$filename";

if ($ext)
{	$filestuff .= ".$ext";
}
$filestuff .= "</a><p>in  <a href=\"file://localhost/$disk:/$parentdirs\">";

if ($disknick!=$defaultdisknick)
{
	$filestuff.= "$disknick - ";
}
$filestuff .= "$disk:/$parentdirs</a>";

	$tagstring_vars=array("maintagstring", "othertagstring", "projectstring", "bundlestring", "otherbundlestring", "authorstring", "languagestring", "originstring", "backuplocstring", "toforstring");

	$changed_tagtypes=array();
	//Then we figure out if the new raw tagstring variables are different from the previous tagstring variables,
	//and clean up any changed tagstrings.

	foreach ($tagstring_vars as $tagstringvar)
	{
		$rawtagstringvar="raw_$tagstringvar";
		if ($action=="Edit")
		{	$prevtagstringvar="prev$tagstringvar";
			$prevtagstringvar=substr($prevtagstringvar, 0, -5); //Getting rid of "tring" at the end.
		}
		$thistagtype=substr($tagstringvar, 0, -6); //Gets rid of "string" at the end.

		if ( ${$rawtagstringvar} != ${$prevtagstringvar} )
		{
			$tags_changed="true";
			${$tagstringvar}=CleanUpTagstring( ${$rawtagstringvar} );
		
			$quotelessvar="quoteless_" . $tagstringvar;	//Later on, the tagstring vars are going to end up
			${$quotelessvar}=${$tagstringvar};		//surrounded by quotes for input into the songinfo table, so we
												//want to preserve a nice, untouched copy of the cleaned-up
											//tagstrings without quotes for when we input the tags into the tags DB.
			array_push($changed_tagtypes, $thistagtype);
		}
	}
	
$nowtimestamp=GetNowTimestamp();

$dateparsers=array("maindateparser", "startdateparser", "enddateparser");

foreach ($dateparsers as $parsername)
{	${$parsername}=$_POST[$parsername];
	$_SESSION[$parsername]=${$parsername};
}

foreach ($dateparsers as $parsername)
{
	if (${$parsername} )
	{	$thistimestamp=MakeIntoUnixTime(${$parsername} );
		$thismonth=date("n", $thistimestamp);
		$thisday=date("j", $thistimestamp);
		$thisyear=date("Y", $thistimestamp);
		$thistime=date("H:i:s", $thistimestamp);
		if ($thistime=="00:00:00")
		{	$thistime=null;
		}
		switch ($parsername)
		{	case "maindateparser": $maindatemonth=$thismonth;
									$maindateday=$thisday;
									$maindateyear=$thisyear;
									$maindatetime=$thistime; break;
			case "startdateparser": $datestartmonth=$thismonth;
									$datestartday=$thisday;
									$datestartyear=$thisyear;
									$datestarttime=$thistime; break;
			case "enddateparser": $datendmonth=$thismonth;
								$datendday=$thisday;
								$datendyear=$thisyear;
								$datendtime=$thistime; break;
		}
	}
}

if ($maindatemonth>12 || $datestartmonth>12 || $datendmonth>12 || $maindateday>31 || $datestartday>31 || $datendday>31)
{
	GoBackToFormWithError("invalid date");
	exit;
}

$times=array("maindatetime", "datestarttime", "datendtime");

foreach ($times as $time)
{	
	if ( ${$time} )
	{	$timestamp=$time . "timestamp";
		${$timestamp}=strtotime(${$time});
		if (${$timestamp}===false)
		{	GoBackToFormWithError("invalid date");
			exit;
		}
		${$time}=date("H:i:s", ${$timestamp});
	}
}


$checkboxes = array(&$status, &$aesthetic, &$utilit, &$educational, &$forfun, &$humorous, &$news, &$curio, &$trivial, &$unknown, &$timecap, &$irrep, &$nostalgic, &$autobio, &$datasource, &$clutterpile, &$permloc, &$maybe, &$aside, &$repository, &$fav, &$important, &$deleted, &$junkpile, &$frequent, &$forother, &$obsolete, &$redundant, &$altversion, &$deletable, &$essential, &$primar, &$hide, &$paired, &$hasthumbnail, &$showthumbnail, &$pairedfolitem);

//altversion - a slightly different alternate version, like a different size of a picture, or slightly changed
//text.

$numberboxes = array(&$usefulness, &$fun, &$beauty, &$necessity, &$humorousness, &$liking, &$updatefrequency, &$interest, &$quality, &$importance, &$relimport, &$desiretoread, &$desiretokeep);

FixCheckboxValues();
FixNumberboxValues();

$varstoinsert=$varstoget_fromform;

if ($raw_extcat=="Image")
{	
	$imvarstoinsert=$imvarstoget_fromform;
}

$allqueryparts=MakeQueryParts($file_id, $varstoinsert);
TrimComma($allqueryparts);


echo "<html><head><title>File Record $file_id Edited</title>
<link rel=stylesheet href='css/f.css' type='text/css'>
</head>
<body><center>";
FilesNav();
$dispcurfilesdb=ucwords($curfilesdb);

echo "<h1>File Record $file_id Edited</h1>
<p>
<big>DB: $dispcurfilesdb</big><p>

$filestuff

<p>
<br>
<div id=\"maintext\">at $nowtimestamp<p>";


	$sqlvarstoinsert=implode(", ", $varstoinsert);

	
	
	$query_to_issue="UPDATE fileinfo SET whenmodified='$nowtimestamp'";
	
	if ($allqueryparts)
	{	$query_to_issue .= ", $allqueryparts";
	}
	$query_to_issue .= " WHERE file_id=$file_id LIMIT 1";
	
	
	/*if ($allqueryparts)
	{
		$query_to_issue="UPDATE fileinfo SET $allqueryparts WHERE file_id=$file_id LIMIT 1";
		echo "<code>$query_to_issue</code><p>";*/

		echo "<code>$query_to_issue</code><p>";
	$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());

		
/*	}
	else
	{	echo "<center>No changes to main table detected, so no update made.</center><p><br>";
	}*/

	$allqueryparts="";
	
	if ($raw_extcat=="Image")
	{	
		$allqueryparts=MakeQueryParts($file_id, $imvarstoinsert);
		TrimComma($allqueryparts);
	
		if ($allqueryparts)
		{	$query_to_issue="UPDATE imageinfo SET $allqueryparts WHERE file_id=$file_id LIMIT 1";
			echo "<code>$query_to_issue</code><p>";
			$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());
		}
		else
		{	echo "<center>No changes to image table detected, so no update made.</center><p>";
		}
	}

//Now, we handle the tags.
if ($tags_changed)
{	$_SESSION[origtags]=$rawtagstring;
	ManageTags("file", $file_id);
}

//Now we get rid of some no longer needed session variables set up by the previous form.

	RemoveFormSessionVars($varstoget_fromform, $file_id);
	
	//foreach ($varstoget_fromform as $varname)
//	{
	///	$sessionvarname=$prevformname . "_orig_" . "$file_id" . "_" . $varname;
	//	unset($_SESSION[$sessionvarname]);
	//	$x++;
	//}
	foreach ($dateparsers as $parsername)
	{	
		unset($_SESSION[$parsername]);
	}
	
	echo "<p><br><br>"; ?>